
//#include "hdf5.h"
#include <cstdlib>
#include <cstdio>
#include <math.h>
#include <string.h>
#include <assert.h>
#include<iostream>
#include "nbody.h"
//#include "kepcart.h"

// take a h5part file and spit out an ascii version
//     printf("xxx.out h5partfilename timestep\n");
// output is a .3D file

using namespace std;

// 
int main(int argc, char *argv[])
{
   SIMinfo siminfo;

   char filename[100];
   char ofilename[100];
   if (argc<2){
     printf("xxx.out h5partfilename \n");
     exit(0);
   }
   strcpy(filename,argv[1]);
   info_h5part(filename, &siminfo); // get number of bodies
   int timestep = 0;
//   sscanf(argv[2],"%d",&timestep);
//   printf("hello\n");

   float *hPos, *hVel;
   int numBodies = siminfo.numBodies;
   hPos = new float[numBodies*4];
   hVel = new float[numBodies*4];
   printf("numBodies %d time=%.3e\n",numBodies,siminfo.time);
   read_h5part(filename, hPos, hVel,  timestep); // get data

   FILE *fpo;
   strcpy(ofilename,filename);
   int pch = strcspn(ofilename,".");
   ofilename[pch]='\0';
   strcat(ofilename,".3D");
   fpo=fopen(ofilename,"w");
   fprintf(fpo,"# x y z m vx vy vz       t=%.3e\n",siminfo.time);
   int i;
   for(i=0;i<numBodies;i++){
     fprintf(fpo,"%11.3e %11.3e %11.3e %11.3e %11.3e %11.3e %11.3e\n",
         hPos[4*i+0], hPos[4*i+1],hPos[4*i+2], hPos[4*i+3],
         hVel[4*i+0], hVel[4*i+1],hVel[4*i+2]);
   }
   fclose(fpo);

   delete [] hPos;
   delete [] hVel;

}

