
//#include "hdf5.h"
#include <cstdlib>
#include <cstdio>
#include <math.h>
#include <string.h>
#include <assert.h>
#include<iostream>
#include "kepcart.h"
#include "nbody.h"

// take a h5part file and spit out an ascii version listing orbital elements
//     printf("xxx.out h5partfilename timestep\n");
// output is a .3D file

using namespace std;
void keplerian(double GM, PhaseState state, OrbitalElements *orbel);


// 
int main(int argc, char *argv[])
{
   SIMinfo siminfo;

   char filename[100];
   char ofilename[100];
   if (argc<2){
     printf("xxx.out h5partfilename \n");
     exit(0);
   }
   strcpy(filename,argv[1]);
   info_h5part(filename, &siminfo); // get number of bodies
   int timestep=0;
//   sscanf(argv[2],"%d",&timestep);
//   printf("hello\n");

   float *hPos, *hVel;
   int numBodies = siminfo.numBodies;
   hPos = new float[numBodies*4];
   hVel = new float[numBodies*4];
//  printf("numBodies %d time=%.3e\n",numBodies,siminfo.time);
   read_h5part(filename, hPos, hVel,  timestep); // get data

   FILE *fpo;
   strcpy(ofilename,filename);
   int pch = strcspn(ofilename,".");
   ofilename[pch]='\0';
   strcat(ofilename,".oe");
   fpo=fopen(ofilename,"w");
   fprintf(fpo,"# m a e i longnode argperi meananom                t=%.3e\n",siminfo.time);
   int i;
   // central star
   float x0  = hPos[4*0+0]; float y0  = hPos[4*0+1]; float z0  = hPos[4*0+2]; 
   float vx0 = hVel[4*0+0]; float vy0 = hVel[4*0+1]; float vz0 = hVel[4*0+2]; 
   float GM = hPos[4*0+3];
   PhaseState pstate;
   OrbitalElements orbel;
   for(i=1;i<numBodies;i++){
     pstate.x  = hPos[4*i+0]-x0;  pstate.y  = hPos[4*i+1]-y0;  
     pstate.xd = hVel[4*i+0]-vx0; pstate.yd = hVel[4*i+1]-vy0; 
     pstate.z  = hPos[4*i+2]-z0;
     pstate.zd = hVel[4*i+2]-vz0;
     float m = hPos[4*i+3];
     keplerian(GM, pstate, &orbel);
     fprintf(fpo,"%11.3e %11.3e %11.3e %11.3e %11.3e %11.3e %11.3e\n",
         m, orbel.a, orbel.e, orbel.i, 
         orbel.longnode, orbel.argperi, orbel.meananom);
   }
   fclose(fpo);

   delete [] hPos;
   delete [] hVel;

}

