

#notes for using python to generate plots with gnuplot
# be careful with spaces in python at beginning of line!

# note you can reload modules with >>> reload(stuff)
# rather than >>> import stuff
# this way they will update when you edit!

import os
from Numeric import *
import Gnuplot, Gnuplot.funcutils
import string
#import pickle

# filename generator
def ofilename(i):
	junks = 'a1_'
	if (i < 10):
		junks = junks + '0'
	if (i < 100): 
		junks = junks + '0'
	if (i < 1000): 
		junks = junks + '0'
	junks = junks + '%d.oe' % (i)  # printing a number
	return junks

# make density histograms xy with inclination arguement
def makedd(xmax,dx,incl):
	os.system("ls *_*.h5part > h5.list")
	f=open('h5.list','r')
	os.system("wc -l h5.list > junks") # get length of file
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	mylist = string.split(wcstring)
	n = int(mylist[0])
	os.system("rm -f h5.list")
	for k in arange(n):
		filename = f.readline()
		js = "mkhist.out " + filename  
		js = string.replace(js, "\n", " ")  \
			+ " " + str(xmax) + " " + str(dx) \
			+ " "  + str(incl) + "> \/dev\/null"
		os.system(js)
		#print js
	f.close()
	

# make ascii orbital element files from h5part files in directory
def makeoe():
	os.system("ls *_*.h5part > h5.list")
	f=open('h5.list','r')
	os.system("wc -l h5.list > junks")
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	os.system("rm -f h5.list")
	mylist = string.split(wcstring)
	n = int(mylist[0])
	for k in arange(n):
		filename = f.readline()
		js = "h5toorb.out " + filename
		os.system(js)
	f.close()

# make 3D ascii files from h5part files 
def make3D():
	os.system("ls *_*.h5part > h5.list")
	f=open('h5.list','r')
	os.system("wc -l h5.list > junks")
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	os.system("rm -f h5.list")
	mylist = string.split(wcstring)
	n = int(mylist[0])
	for k in arange(n):
		filename = f.readline()
		js = "h5to3D.out " + filename
		os.system(js)
	f.close()

# print every nth line orbital elements into a file with time
# useful for showing a planet with time
def oeplanet(n):
	os.system("ls *_*.oe > oe.list")   # oe.list is all .oe files
	f=open('oe.list','r')
	os.system("wc -l oe.list > junks") # find # of files in list
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	mylist = string.split(wcstring)
	nf = int(mylist[0])
	ofilename= "p" + str(n) + ".oe"
	tofilename= "pp" + str(n) + ".oe"  # temporary
	os.system("rm -f " + tofilename)
	print ofilename
	for k in arange(nf):
		filename = f.readline()
		# get nth line with awk
		js = "awk \'NR==" + str(n+1) + "{print;exit}\' " + filename
		# strip the \n and append to ofile 
		js = string.replace(js, "\n", " ") + ">> " + tofilename
		#print js #test to see command
		os.system(js) # run awk command
	f.close()
	# ppx.oe now has orbital elements but not time
	f=open('oe.list','r')
	ltfilename='longtimelist'
	os.system("rm -f " + ltfilename)
	for k in arange(nf):
		filename = f.readline()
		# get 1rst line with awk
		js = "awk \'NR==1 {print;exit}\' " + filename
		js = string.replace(js, "\n", " ") + ">> " + ltfilename
		os.system(js) # run awk command
	f.close()
	# longtimelist now has list of times in it
	f1=open(ltfilename,'r')
	f2=open(tofilename,'r')
	f3=open(ofilename,'w')
	js = "#orbel for planet " + str(n) 
	f3.write(js + '\n')
	js = "#time m a e i longnode argperi meananon "
	f3.write(js + '\n')
	for k in arange(nf):
		oes= f2.readline()
		js = f1.readline()
		xx = string.split(js,'t=')
		jjs = string.replace(xx[1] + oes,"\n", " ")
		#print jjs  #test
		f3.write(jjs + '\n')
	# px.oe has time followed by m and orbels
	f1.close()
	f2.close()
	f3.close()
	os.system("rm " + tofilename) #cleanup
	os.system("rm " + ltfilename)
	os.system("rm -f oe.list")


# t, a1, a2 into one file called p.a
def cat_a():
        os.system('awk \'NR>2 {print $1,$3}\' p1.oe > junk1')
        os.system('awk \'NR>2 {print $3}\' p2.oe > junk2')
        os.system('echo \#  t a1 a2 > p.a')
        os.system('pr -T -m junk1 junk2 >> p.a')
	os.system('rm -f junk1')
	os.system('rm -f junk2')

def aemovie(xmax,nplanets):
	g = Gnuplot.Gnuplot()
	#g('load "../aeset.gnu"')
	g('set pointsize 2')
	g('set xlabel \"a\"')
	g('set ylabel \"e\"')
	g('set yrange [-0.03:1]')
	g('set xrange [0:'+ str(xmax) + '1]')
	g('set term png')
	os.system("ls *_*.oe > oe.list")   # oe.list is all .oe files
	os.system("wc -l oe.list > junks") # find # of files in list
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	mylist = string.split(wcstring)
	nf = int(mylist[0])
	f=open('oe.list','r')
	for k in arange(nf):
		filename = f.readline()
		sssn = ""
		if (k < 10):
			sssn = sssn + "0"
		if (k < 100):
			sssn = sssn + "0"
		if (k < 1000):
			sssn = sssn + "0"
		sssn = sssn + str(k)
		ofilename="ae" + sssn + ".png"
		js = 'set output ' + "\"" + ofilename + "\""
		g(js)
		pfilename = '\"' + string.replace(filename, "\n", "") + '\"' 
		js = 'plot ' + pfilename + ' using 2:3 with points ps 0.25 pt 5 notitle'
		if (nplanets>1):
			js = js + ', ' 
			npstring = str(nplanets-1)
			js = js + pfilename + 'every ::0::' + npstring 
			js= js + ' using 2:3 with points ps 3 pt 7 lw 2 notitle '
		g(js)
	f.close()

def aimovie(xmax,nplanets):
	g = Gnuplot.Gnuplot()
	#g('load "../aiset.gnu"')
	g('set pointsize 2')
	g('set xlabel \"a\"')
	g('set ylabel \"i\"')
	g('set yrange [-0.03:1]')
	g('set xrange [0:'+ str(xmax) + '1]')
	g('set term png')
	os.system("ls *_*.oe > oe.list")   # oe.list is all .oe files
	os.system("wc -l oe.list > junks") # find # of files in list
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	mylist = string.split(wcstring)
	nf = int(mylist[0])
	f=open('oe.list','r')
	for k in arange(nf):
		filename = f.readline()
		sssn = ""
		if (k < 10):
			sssn = sssn + "0"
		if (k < 100):
			sssn = sssn + "0"
		if (k < 1000):
			sssn = sssn + "0"
		sssn = sssn + str(k)
		ofilename="ai" + sssn + ".png"
		js = 'set output ' + "\"" + ofilename + "\""
		g(js)
		pfilename = '\"' + string.replace(filename, "\n", "") + '\"' 
		js = 'plot ' + pfilename + ' using 2:4 with points ps 0.25 pt 5 notitle'
		if (nplanets>1):
			js = js + ', ' 
			npstring = str(nplanets-1)
			js = js + pfilename + 'every ::0::' + npstring 
			js = js + ' using 2:4 with points ps 3 pt 7 lw 2 notitle '
		#print js
		g(js)
	f.close()

def ddmovie(zrange):
	g = Gnuplot.Gnuplot()
	g('set nokey')
	g('set xlabel \"x\"')
	g('set ylabel \"y\"')
	g('unset surface')
	g('set view map')
	g('set pm3d')
	g('set size square')
	g('set term gif')
	js = 'set zrange [0:'+ str(zrange) + ']'
	g(js)
	js = 'set cbrange [0:'+ str(zrange) + ']'
	g(js)
	g('unset autoscale cb')
	os.system("ls *_*.d > d.list")   # d.list is all .d files
	os.system("wc -l d.list > junks") # find # of files in list
	f2 = open('junks','r')
	wcstring=f2.readline()
	f2.close()
	os.system("rm junks")
	mylist = string.split(wcstring)
	nf = int(mylist[0])
	f=open('d.list','r')
	for k in arange(nf):
		filename = f.readline()
		sssn = ""
		if (k < 10):
			sssn = sssn + "0"
		if (k < 100):
			sssn = sssn + "0"
		if (k < 1000):
			sssn = sssn + "0"
		sssn = sssn + str(k)
		ofilename="dd" + sssn + ".gif"
		js = 'set output ' + "\"" + ofilename + "\""
		g(js)
		pfilename = '\"' + string.replace(filename, "\n", "") + '\"' 
		js = 'splot ' + pfilename 
		#print js
		g(js)
	f.close()
	os.system("rm -f d.list")

def oenplanets(nplanets):
	for k in arange(nplanets):
	        oeplanet(k+1)  # make a list of oes for planet k
	x=1

# plot a of all planets together eps file
def tplot(nplanets,tmax):
	g = Gnuplot.Gnuplot()
	g('set xrange [0:' + str(tmax) + ']')
	g('set yrange [0:2.0]')
	g('set xlabel \"t\"')
	g('set ylabel \"a\"')
	g('set term postscript eps enhanced lw 2 "Helvetica" 22')
        g('set output "pp.eps"')
	js = "plot "
	ks = ' using ($1/(2*pi)):3:($3*(1-$4)):($3*(1+$4)) with yerrorbars notitle'
	for k in arange(nplanets):
		ofilename= "p" + str(k+1) + ".oe"
		js = js	 + "\"" + ofilename + "\""
		js = js + ks
		if (k < nplanets-1):
			js = js + ", "
	g(js)

