#include<fstream>
#include<iostream>
#include<sstream>
#include<cstdio>
#include<cstdlib>
using namespace std;
#include "nbody.h"

// void sread(char *parmfile,  SIMinfo *siminfo);
//extern "C" { }


// read in the simulations input structure from a parameter file
#define SLEN 256
void sread(char *parmfile,  SIMinfo *siminfo)
{
  ifstream filestr;
  char pline[SLEN];
  istringstream iss;
  filestr.open(parmfile, fstream::in);

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->numBodies;
//  cout << siminfo->numBodies << endl;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->deltaTime;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->damping;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->softening;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->niter;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->ndt;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->amin;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->amax;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->gamma;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->ibar;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->m;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->nplanets;

  for(int j=0;j<siminfo->nplanets;j++){
    double a,e,ii,longnode,argperi,meananom;
    filestr.getline(pline,SLEN);
    iss.str(pline);
    iss >> siminfo->mplanets[j] 
        >> a >> e >> ii >> longnode >> argperi >> meananom;  
//    cout << siminfo->mplanets[j]<< "," << a << "," << e << "," << ii << endl;
//    cout <<  longnode << "," << argperi << "," << meananom << endl;
    siminfo->orbel[j].a=a;
    siminfo->orbel[j].e=e;
    siminfo->orbel[j].i=ii;
    siminfo->orbel[j].longnode=longnode;
    siminfo->orbel[j].argperi=argperi;
    siminfo->orbel[j].meananom=meananom;
  }
  
//  cout << siminfo->numBodies << endl;


  filestr.close();

}
     
// correct for center of mass drift 
// off gpu
void correctcom(float *hPos, float *hVel, int numBodies)
{
  float sumx=0.0; float sumy=0.0; float sumz=0.0;
  float sumvx=0.0; float sumvy=0.0; float sumvz=0.0;
  float summ=0.0;
  for (int i=0;i<numBodies;i++){
     float m = hPos[4*i+3];
     summ += m;
     sumx  += m*hPos[4*i+0]; sumy  += m*hPos[4*i+1]; sumz  += m*hPos[4*i+2];
     sumvx += m*hVel[4*i+0]; sumvy += m*hVel[4*i+1]; sumvz += m*hVel[4*i+2];
  }
  float cx  = sumx /summ; float cy  =  sumy /summ; float cz  = sumz /summ;
  float cvx = sumvx/summ; float cvy =  sumvy/summ; float cvz = sumvz/summ;
  for (int i=0;i<numBodies;i++){
     hPos[4*i+0] -= cx;  hPos[4*i+1] -= cy;  hPos[4*i+2] -= cz;
     hVel[4*i+0] -= cvx; hVel[4*i+1] -= cvy; hVel[4*i+2] -= cvz;
  }
}

